#
# Note: Start powershell.exe as Administrator. Then run the Build.ps1
# Note: Place data.zip on Administrator Desktop. C:\Users\Administrator\Desktop\data.zip
#

echo "[+] Building Symbolic"
echo "[+] OS: Windows Server 2019"
echo "[+] Author: Enox"

Write-Host "[*] Extracting data.zip"
Expand-Archive -LiteralPath C:\Users\Administrator\Desktop\data.zip -DestinationPath C:\Windows\Temp 
del C:\Users\Administrator\Desktop\data.zip

Write-Host "[*] Disabling Defender"
Set-MpPreference -DisableRealtimeMonitoring $true


Write-Host "[*] Configuring SSH"
# Install the OpenSSH Client
Add-WindowsCapability -Online -Name OpenSSH.Client~~~~0.0.1.0

# Install the OpenSSH Server
Add-WindowsCapability -Online -Name OpenSSH.Server~~~~0.0.1.0

# OPTIONAL but recommended:
Start-Service sshd
Set-Service -Name sshd -StartupType 'Automatic'

# Creating Firewall Rule
New-NetFirewallRule -DisplayName 'Port 22 for SSH' -Profile 'Any' -Direction Inbound -Action Allow -Protocol TCP -LocalPort 22

# Copying config
copy C:/Windows/Temp/data/sshd_config C:\ProgramData\ssh\sshd_config
restart-service sshd

##########################################################################################


Write-Host "[1] Setting up Foothold - Apache"

Write-Host "[1.1] Creating Apache Service Account"
# Disabling Password Complexity
secedit /export /cfg c:\secpol.cfg
(gc C:\secpol.cfg).replace("PasswordComplexity = 1", "PasswordComplexity = 0") | Out-File C:\secpol.cfg
secedit /configure /db c:\windows\security\local.sdb /cfg c:\secpol.cfg /areas SECURITYPOLICY
rm -force c:\secpol.cfg -confirm:$false
gpupdate /force

# Adding user
net user p4yl0ad "MahBoiLD!!" /add

## Configuring User
$apache = ConvertTo-SecureString 'MahBoiLD!!' -AsPlainText -Force
$Cred = New-Object System.Management.Automation.PSCredential('SYMBOLIC\p4yl0ad', $apache)
Start-Process PowerShell -Cred $Cred -ArgumentList 'whoami' -WorkingDirectory 'C:\'

Write-Host "[1.2] Setting up XAMPP"
# Downloading and Extracting
iwr -uri 'https://master.dl.sourceforge.net/project/xampp/XAMPP%20Windows/8.0.7/xampp-portable-windows-x64-8.0.7-0-VS16.zip?viasf=1' -outfile C:\Windows\Temp\xampp.zip -TimeoutSec 9999999
Expand-Archive -LiteralPath C:\Windows\Temp\xampp.zip -DestinationPath "C:\"
rmdir -r C:\xampp\htdocs

Write-Host "[1.3] Adding Website Files"
robocopy C:\Windows\Temp\data\htdocs C:\xampp\htdocs /COPYALL /E


Write-Host "[1.4] Installing wkhtmltopdf"
iwr -uri 'https://github.com/wkhtmltopdf/wkhtmltopdf/releases/download/0.12.3/wkhtmltox-0.12.3_msvc2013-win64.exe' -outfile C:\Windows\Temp\wkhtml.exe -TimeoutSec 9999999
mkdir C:\wkhtml
C:\Windows\Temp\wkhtml.exe /S /D=C:\wkhtml


Write-Host "[1.5] Configuring Service"
# Giving Privileges
$Identity = "SYMBOLIC\p4yl0ad"
$CarbonDllPath = "C:\Windows\Temp\data\Carbon\bin\Carbon.dll"
[Reflection.Assembly]::LoadFile($CarbonDllPath)
[Carbon.Lsa]::GrantPrivileges( $Identity , "SeServiceLogonRight" )
[Carbon.Lsa]::GrantPrivileges( $Identity , "SeTcbPrivilege" )

# Setting Perms
cmd /c 'icacls "C:\xampp" /grant p4yl0ad:(OI)(CI)F /T'

# Creating Service
C:\Xampp\apache\bin\httpd.exe -k install -n "Apache HTTP Server"
cmd /c sc.exe config "ApacheHTTPServer" obj= ".\p4yl0ad" password= "MahBoiLD!!"
cmd /c sc.exe privs ApacheHTTPServer SeChangeNotifyPrivilege/SeCreateGlobalPrivilege/SeIncreaseWorkingSetPrivilege
sleep 5
cmd /c sc.exe start ApacheHTTPServer


Write-Host "[1.6] Adding Firewall Rule"
New-NetFirewallRule -DisplayName 'Port 80 for Apache' -Profile 'Any' -Direction Inbound -Action Allow -Protocol TCP -LocalPort 80

Write-Host "[1.7] Configuring SSH Keys"
$apache = ConvertTo-SecureString 'MahBoiLD!!' -AsPlainText -Force
$Cred = New-Object System.Management.Automation.PSCredential('SYMBOLIC\p4yl0ad', $apache)
Start-Process PowerShell -Cred $Cred -ArgumentList 'mkdir C:/Users/p4yl0ad/.ssh' -WorkingDirectory 'C:\'
sleep(5)
Start-Process 'C:\Windows\System32\OpenSSH\ssh-keygen.exe' -Cred $Cred -ArgumentList '-o -a 100 -f C:/users/p4yl0ad/.ssh/id_rsa -q -N ""' -WorkingDirectory 'C:\'
sleep (5)
Start-Process PowerShell -Cred $Cred -ArgumentList 'copy C:/users/p4yl0ad/.ssh/id_rsa.pub C:/users/p4yl0ad/.ssh/authorized_keys' -WorkingDirectory 'C:\'

##########################################################################################

Write-Host "[2] Setting up Privesc - Backup Service"

Write-Host "[2.1] Configuring Backup Folder"
mkdir C:\backup ; mkdir C:\backup\logs
copy C:\Windows\Temp\data\backup.ps1 C:\backup\backup.ps1

# Setting Perms
cmd /c 'icacls "C:\backup" /grant Administrator:(OI)(CI)F /T'
cmd /c 'icacls "C:\backup\backup.ps1" /grant Administrator:(OI)(CI)F /T'
cmd /c 'icacls "C:\backup\logs" /grant Administrator:(OI)(CI)F /T'


Write-Host "[2.2] Creating Backup Service using nssm"
# Retrieving nssm
Invoke-WebRequest -uri 'https://nssm.cc/release/nssm-2.24.zip' -outfile C:\Windows\Temp\nssm.zip
Expand-Archive -LiteralPath C:\Windows\Temp\nssm.zip -DestinationPath "C:\Program Files"
cmd /c 'icacls "C:\Program Files\nssm-2.24" /grant Everyone:rx /T'

# Creating service
& "C:\Program Files\nssm-2.24\win64\nssm.exe" install BackupLogService "C:\Windows\System32\WindowsPowerShell\v1.0\powershell.exe" "-ExecutionPolicy Bypass -NoProfile -File C:\backup\backup.ps1"
& "C:\Program Files\nssm-2.24\win64\nssm.exe" set BackupLogService ObjectName 'SYMBOLIC\Administrator' 'SymbolicLinks2021!'
& "C:\Program Files\nssm-2.24\win64\nssm.exe" set BackupLogService Start SERVICE_AUTO_START
cmd /c 'sc failure BackupLogService reset= 0 actions= restart/20/restart/20/restart/20'
cmd /c 'sc privs BackupLogService SeChangeNotifyPrivilege/SeCreateGlobalPrivilege/SeIncreaseWorkingSetPrivilege'
& "C:\Program Files\nssm-2.24\win64\nssm.exe" start BackupLogService


Write-Host "[2.3] Configuring ssh keys"
mkdir C:\users\administrator\.ssh
sleep(5)
ssh-keygen -o -a 100 -f C:/users/Administrator/.ssh/id_rsa -q -N """"
copy C:\users\administrator\.ssh\id_rsa.pub C:\Users\administrator\.ssh\authorized_keys

##########################################################################################

Write-Host "[*] Wrapping Up"

Write-Host "[+] Creating Flags"
New-Item "C:\Users\Administrator\Desktop\proof.txt"
Set-Content "C:\Users\Administrator\Desktop\proof.txt" "9cbc44e1bcbff71a1d02a37b45a31fe3"
New-Item "C:\Users\p4yl0ad\Desktop\local.txt"
Set-Content "C:\Users\p4yl0ad\Desktop\local.txt" "9a4bf53583f6e275af6b9fce84f9b456"

Write-Host "[+] Disabling IPv6"
Disable-NetAdapterBinding -Name "*" -ComponentID ms_tcpip6

Write-Host "[+] Disabling Sleep Mode"
powercfg /Change monitor-timeout-ac 0
powercfg /Change monitor-timeout-dc 0
powercfg /Change standby-timeout-ac 0
powercfg /Change standby-timeout-dc 0
powercfg /Change hibernate-timeout-ac 0
powercfg /Change hibernate-timeout-dc 0

Write-Host "[+] Disabling Windows Update"
sc stop WaasMedicSvc
sc stop wuauserv
sc stop UsoSvc
Set-ItemProperty -Path "HKLM:\SYSTEM\CurrentControlSet\Services\wuauserv" -Name "Start" -Value 4

Write-Host "[+] Cleaning Up"
Remove-Item -path C:\Windows\Temp\* -Recurse -Force
Remove-Item "C:\Users\*\AppData\Roaming\Microsoft\Windows\Recent\*" -Recurse -Force -ErrorAction SilentlyContinue
Remove-Item "C:\Users\*\AppData\Local\Temp\*" -Recurse -Force -ErrorAction SilentlyContinue
Remove-Item "C:\`$Recycle.Bin\*" -Recurse -Force -ErrorAction SilentlyContinue
Remove-Item "C:\Users\*\AppData\Roaming\Microsoft\Windows\PowerShell\PSReadLine\ConsoleHost_history.txt" -Force -ErrorAction SilentlyContinue

del stop
del Pre-Config.ps1
del Build.ps1
